︠3f76a230-8723-49d7-ab69-3bca04e4878ai︠
%html
<h1><center>RSA CRYPTOSYSTEM</center></h1>
︡f6f3407f-532f-4953-86f0-aa9103c0ae6d︡{"done":true,"html":"<h1><center>RSA CRYPTOSYSTEM</center></h1>"}
︠62aff6fb-2ed8-4347-a338-4df3b081b877i︠
%html
<h2><center>ASCIIPad Procedures</center></h2>
︡d4d0b01d-dd0c-4871-b8fe-02cb13c12605︡{"done":true,"html":"<h2><center>ASCIIPad Procedures</center></h2>"}
︠ee1bd8c7-0dd8-47c5-b91b-bb1dceede743s︠


def ASCIIPad(Message):
    newList = []
    messLen = len(Message)
    tempIter = messLen - 1
    while tempIter >= 0:
        newList.append(Message[tempIter])
        tempIter -= 1
    x = [100+ord(newList[i]) for i in range(messLen)];
    x = ZZ(x,1000);
    return(x);


def ASCIIDepad(Number):
    n = Number.ndigits() % 3;
    if (n > 0):
        print("This is not a padded ASCII string\n");
    else:
        L = [((Number - (Number % (1000^i)))/1000^i)%1000 - 100 for i in range(Number.ndigits()/3)];
        N = "";
        for i in range(Number.ndigits()/3):
            N = chr(L[i]) + N;
        return(N)
    
def isASCIIPadded(Number):
    N = ""
    n = Number.ndigits() % 3;
    if (n > 0):
        return False;
    L = [((Number - (Number % (1000^i)))/1000^i)%1000 - 100 for i in range(Number.ndigits()/3)];
    for i in range(Number.ndigits()/3):
        if L[i] < 0:
            return False
        if L[i] > 255:
            return False
    return True

︡2e7304cd-0475-497e-bdf9-3d0764bdea45︡{"done":true}
︠81600dc9-8b89-408b-8d7f-b7584aa5abf4i︠
%html
<h2><center>RSA Encryption</center></h2>
︡e4705034-c0d3-41a9-b688-ec8f7c4050d7︡{"done":true,"html":"<h2><center>RSA Encryption</center></h2>"}
︠22460355-b4fa-4c9d-8416-b1bd93d2cb1f︠

def rsaencrypt(Message, encrexp, encrmod):
    A = ASCIIPad(Message);
    E = power_mod(A,encrexp,encrmod);
    return(E);

︠b7b84e69-a0c5-43a2-ab5e-f94a0452cc77i︠
%html
<h2><center>RSA Decryption</center></h2>
︡873284f5-c03e-4932-a731-38ceaadea044︡{"done":true,"html":"<h2><center>RSA Decryption</center></h2>"}
︠3d021c79-8fb8-4565-b4f7-53175189f47bs︠

def rsadecrypt(Ciphertext, decexp, decmod):
    P = power_mod(Ciphertext, decexp, decmod) 
    unpaddedMess = ASCIIDepad(P)
    return(unpaddedMess)
︡57ee233a-d235-4354-9ec7-a471d1a533c9︡{"done":true}
︠16262edb-79e0-4cf2-a9d7-78d1d5d21822i︠
%md
<b>Example.</b> The following example illustrates step-by-step RSA encryption and decryption.
︡684a1e9f-d24e-414f-803c-8794797ec256︡{"done":true,"md":"<b>Example.</b> The following example illustrates step-by-step RSA encryption and decryption."}
︠8e30ddf8-0c0d-439f-bd3f-dc1f11216e0fs︠
########################################## Choose two primes p and q ##################################
p = next_prime(861786187687436287634876534289765348257634287956239487652349785634875634875)
q = next_prime(7345678659826873465873492654392856349285734342875687689734569384275698374563847956349875)
########################################## Compute the product p*q and (p-1)*(q-1)######################
N = p*q
phiN=(p-1)*(q-1)
########################################## Choose a random number e< N such that gcd(e, phiN)=1 ########
e = 101
########################################## Compute the private key d ###################################
d=1/e %  phiN

############### The RSA private key is d and the RSA public key is N,e. ################################
︡47510f2e-44d0-40f0-8760-0938ebe6ddb0︡{"done":true}
︠5622fc9f-c624-43cf-bd10-d2a2a3d7427fs︠
######################################### Choose a plaintext ###########################################
M="Crypto is used everywhere."
######################################### Convert the plaintext into a number ##########################
m=ASCIIPad(M)
######################################### Encrypt the message ##########################################
E = rsaencrypt(M,e,N)
print(E)
︡17a908b7-6fb7-4e49-a430-4991a58cb0fd︡{"stdout":"979153975075107784281799842594898949688234055468244298885509654151181066422087535039031049660169647247652878439563659738124018482375543000035994478937003968901276\n"}︡{"done":true}
︠43fc888b-a7b9-4a10-9cbb-5118a2d4ac47s︠

######################################### Decrypt the ciphertext E #####################################
rsadecrypt(E,d,N)

︡fe4bfedb-1c5c-40b1-b1e2-3fb781b5e257︡{"stdout":"'Crypto is used everywhere.'\n"}︡{"done":true}









